/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// 一括登録ファイルアップロード・アクションクラス
// 
//
//	変更履歴
//		2004.01.08 新規作成 T.Nishiki 
//
package jp.co.ntt.lms.xms.lumpfile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.xmo.LumpInsert.LumpInsertClient;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsMessages;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsWarningException;
import jp.co.ntt.lms.xms.common.user.User;
import jp.co.ntt.lms.xms.common.util.CommonUtil;
import jp.co.ntt.lms.xms.common.util.StringUtil;

/**
 * 一括登録ファイルアップロード・アクションクラス。
 * @author T.Nishiki
 */
public class LumpFileUploadAction extends XmsBusinessAction {

	/**
	 * リクエスト処理初期化メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void initProcessRequest(XmsRequest xmsRequest)
		throws XmsException {
	}

	/**
	 * リクエスト処理メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void processRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {

		// 一括登録クライアント
		LumpInsertClient client = null;
		// アップロードファイル内容
		String strUploadFile = null;
		// ログインユーザーのID
		User user = null;
		// 入力項目データクラス
		LumpFileInputBean inputBean = null;
		// エラーメッセージ。この変数に値が入っている場合は、
		// XmsWarningExceptionのエラーメッセージより優先される。
		String errorMessage = null;
		// アップロード完了メッセージ
		String completeMessage = null;
		// 一括登録ファイル名取得
		String strLumpFileName = null;

		try {
			////////////////////////////////////////////////////////////////////
			// ログインユーザー取得
			user = CommonUtil.getLoginUser(xmsRequest);
			// ユーザ取得に失敗
			if (user == null ) {
				throw new XmsWarningException(
						LumpFileConstant.KEY_MESSAGE_NO_LOGIN_USER);
			}
			////////////////////////////////////////////////////////////////////
			// 入力項目の取得
			inputBean = getInputBean(xmsRequest);
			// アップロードファイル値取得
			strUploadFile = xmsRequest.getParameter(LumpFileConstant.NAME_UPLOAD_FILE);
			////////////////////////////////////////////////////////////////////
			// アップロードファイル登録処理
			// =================================================================
			// 一括登録クライアント生成
			client = new LumpInsertClient();
			// アップロードファイル設定
			client.setLumpFile(strUploadFile);
			// ログインID設定
			client.setLoginID(user.getLoginID());
			// 登録先グループID
			client.setLumpRootGroup(inputBean.getParentID());
			// =================================================================
			// アップロード実行
			boolean uploadResult = false;
			uploadResult = client.upload();
			if (uploadResult == false) {
				errorMessage = client.getMessage();
				throw new XmsWarningException(
						LumpFileConstant.KEY_MESSAGE_FAIL_UPLOAD);
			}
			// =================================================================
			// 一括登録ファイル名取得
			strLumpFileName = xmsRequest.getParameterFilePath(LumpFileConstant.NAME_UPLOAD_FILE);
			strLumpFileName = client.getLumpFileName();
			inputBean.setLumpFileName(strLumpFileName);

			// =================================================================
			// アップロード完了メッセージ
			completeMessage = XmsMessages.getString(
				LumpFileConstant.KEY_MESSAGE_COMPLETE_UPLOAD);
			inputBean.setUploadCompleteMessage(completeMessage);
		} catch (XmsException e) {
			// エラーメッセージがない場合、Exceptionからメッセージを取得する。
			if ( StringUtil.isNullString(errorMessage) == true ) {
				errorMessage = e.getMessage();
			}
			LumpFileUtil.setErrorInformation(
				xmsResponse, errorMessage );

		} catch (Exception e) {
			DebugLog.write(this.getClass(), e, DebugLog.HIGHT);
			throw new XmsInnerException(e);
		}
	}

	/**
	 * 送信されてきた情報から、LumpFileInputBeanを生成する。<br>
	 * @param xmsRequest リクエスト・オブジェクト。
	 * @return 生成したCustomAssignInputBeanオブジェクト。
	 */
	private LumpFileInputBean getInputBean(XmsRequest xmsRequest)
		throws XmsException {
		// このメソッドの戻り値。
		LumpFileInputBean inputBean = null;

		// セッション取得用
		HttpServletRequest request = null;
		// セッション登録用
		HttpSession session = null;

		try {
			inputBean = new LumpFileInputBean();
			// =================================================================
			// 登録先親グループID
			String parentID = null;
			parentID = xmsRequest.getParameter(LumpFileConstant.NAME_PARENT_ID);
			inputBean.setParentID(parentID);
			// =================================================================
			// メール送信
			String submitMail = null;
			int intSubmitMail = 0;
			submitMail =
				xmsRequest.getParameter(LumpFileConstant.NAME_SUBMIT_MAIL);
			intSubmitMail =
				StringUtil.parseInt(
					submitMail,
					LumpFileConstant.SUBMIT_NO_MAIL);
			inputBean.setSubmitMail(
				intSubmitMail == LumpFileConstant.SUBMIT_MAIL);
			// アップロードは成功していない状態
			inputBean.clearUploadCompleteMessage();
			// =================================================================
			// セッションに登録
			request = xmsRequest.getRequest();
			session = request.getSession(false);
			if (session != null) {
				session.setAttribute(LumpFileConstant.KEY_INPUT_BEAN, inputBean);
			}
			
		} catch (Exception e) {
			DebugLog.write(
				this.getClass(),
				"Exception occured at getInputBean:" + e,
				DebugLog.HIGHT);
			throw new XmsInnerException(e);
		}
		return inputBean;
	}
}
